library tencent_im_sdk;

import 'package:tencent_im_sdk_mobile/tencent_im_sdk_mobile.dart'
    if (dart.library.io) 'package:tencent_im_sdk_mobile/tencent_im_sdk_mobile.dart'
    if (dart.library.html) 'package:tencent_im_sdk_web/tencent_im_sdk_web.dart';
import 'package:tencent_im_sdk_platform_interface/tencent_im_sdk_platform_interface.dart';

export 'package:tencent_im_sdk_platform_interface/tencent_im_sdk_platform_interface.dart';

class TIMSdk {
  factory TIMSdk() {
    return _instance;
  }

  TIMSdk._internal() {
    _sdk = TIMSdkApp();
    message = MessageManager();
    group = GroupManager();
  }

  static TIMSdk _instance = TIMSdk._internal();

  TIMSdkPlatform? _sdk;
  MessageManagerPlatform? message;
  GroupManagerPlatform? group;

  Stream<TIMEvent> get eventListener {
    return _sdk!.eventListener;
  }

  Future<String> get sdkVersion => _sdk!.sdkVersion;

  Future<void> init({
    required int appId,
    TIMLogLevel logLevel = TIMLogLevel.off,
  }) async {
    await _sdk!.init(appId: appId, logLevel: logLevel);
    message!.init();
    group!.init();
    return;
  }

  Future<void> unInit() {
    return _sdk!.unInit();
  }

  Future<void> login({
    required String userId,
    required String userSign,
  }) {
    print('sdsdadsd');
    return _sdk!.login(userId: userId, userSign: userSign);
  }

  Future<void> logout() {
    return _sdk!.logout();
  }

  void dispose() {
    message!.dispose();
    group!.dispose();
    _sdk!.dispose();
  }
}
